#!ruby -Ke
#
#  TOPPRES/A-CANIF
#      Automotive CANIF
#
#  Copyright (C) 2013-2014 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2013-2014 by FUJI SOFT INCORPORATED, JAPAN
#  Copyright (C) 2013-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
#  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
#  Copyright (C) 2013-2014 by Sunny Giken Inc., JAPAN
#  Copyright (C) 2013-2014 by TOSHIBA CORPORATION, JAPAN
#  Copyright (C) 2013-2014 by Witz Corporation, JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
#  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
#  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
#  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: check_spec_coverage.rb 425 2014-09-17 00:46:01Z fsi-dankei $
#

#
#  ͥХåå
#

if ($0 == __FILE__)
  TOOL_ROOT = File.expand_path(File.dirname(__FILE__) + "/")
  $LOAD_PATH.unshift(TOOL_ROOT)
end

require "pp"

# AUTOSAR
aAutosarSpecId = File.read("#{TOOL_ROOT}/autosar/autosar_spec_id.txt").split("\n")

# Ѥߥե
aImplSpecId = []
aFileData = File.read("#{TOOL_ROOT}/implementation/impl_spec_id.txt").split("\n")
aFileData.each{|sLine|
  if (sLine =~ /^[\[<]CANIF[0-9][0-9][0-9][_Conf]*[\]>].*$/)
    aImplSpecId.push(sLine.gsub(/^[\[<](CANIF[0-9][0-9][0-9][_Conf]*)[\]>].*$/, "\\1"))
  end
}

# ̤
aNonImplTags = []
aAutosarSpecId.each{|sTag|
  if (!aImplSpecId.include?(sTag))
    aNonImplTags.push(sTag)
  end
}

# ɽ
puts("=" * 30)
puts("AUTOSAR tags    : #{aAutosarSpecId.size()}")
puts("Implemented tags: #{aImplSpecId.size()}")
fCoverage = aImplSpecId.size().to_f() / aAutosarSpecId.size().to_f() * 100
puts("Spec Coverage   : #{sprintf('%0.1f', fCoverage)} %")
puts("-" * 30)
puts("Not implementation tags: #{aNonImplTags.size()}")
puts("=" * 30)
aNonImplTags.each{|sTag|
  puts(sTag)
}

# AUTOSARͤˤʤƤʤå
aImplSpecId.each{|sTag|
  if (!aAutosarSpecId.include?(sTag))
    puts("!! Not exist tag: #{sTag}")
  end
}

