#!ruby -Ke
#
#  TOPPRES/A-COM
#      Automotive COM
#
#  Copyright (C) 2013-2014 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2013-2014 by FUJI SOFT INCORPORATED, JAPAN
#  Copyright (C) 2013-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
#  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
#  Copyright (C) 2013-2014 by Sunny Giken Inc., JAPAN
#  Copyright (C) 2013-2014 by TOSHIBA CORPORATION, JAPAN
#  Copyright (C) 2013-2014 by Witz Corporation, JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
#  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
#  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
#  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: get_spec_id.rb 425 2014-09-17 00:46:01Z fsi-dankei $
#

#
#  λͥФ
#

if ($0 == __FILE__)
  TOOL_ROOT = File.expand_path(File.dirname(__FILE__) + "/")
  $LOAD_PATH.unshift(TOOL_ROOT)
end

require "pp"

# оݥե
aTargetFiles = []
aTargetFiles.push("#{TOOL_ROOT}/../../Com.c")
aTargetFiles.push("#{TOOL_ROOT}/../../Com.h")
aTargetFiles.push("#{TOOL_ROOT}/../../Com.tf")
aTargetFiles.push("#{TOOL_ROOT}/../../../general/ComStack_Types.h")

# NCOMͽ
aNCOMSpecFiles = []
aNCOMSpecFiles.push("#{TOOL_ROOT}/../../doc/com_spec.txt")
aNCOMSpecFiles.push("#{TOOL_ROOT}/../../doc/com_container.txt")
aNCOMSpecFiles.push("#{TOOL_ROOT}/../../doc/com_system_service.txt")

# оݥɽ
sTagRegNcom = "NCOM[0-9][0-9][0-9]"
sTagRegComA = "COMa[0-9][0-9][0-9]"
sTagRegCom = "COMa?[0-9][0-9][0-9][_Conf]*"
sTagRegAll = "N?#{sTagRegCom}"

#
# NCOMCOMaͼ
#
aSpecData = []
aNCOMSpecFiles.each{|sFileName|
  sFileData = File.read(sFileName)
  # ԥɤѴ
  if (sFileData.include?("\r\n"))
    sFileData.gsub!("\r\n","\n")
  end
  if (sFileData.include?("\r"))
    sFileData.gsub!("\r","\n")
  end

  aTmpData = sFileData.split("\n")

  # [1ΥɡԿե̾]ΥåȤݻ
  nLine = 1
  aTmpData.each{|sLine|
    aSpecData.push([sLine, nLine, File.basename(sFileName)])
    nLine += 1
  }
}

# 
hNcomSpecInfo = {}

aSpecData.each{|aLine|
  # ͥ¸ߤʤϲ⤷ʤ
  if ((aLine[0] !~ /\[#{sTagRegNcom}\]/) && (aLine[0] !~ /\[#{sTagRegComA}\]/))
    next
  end

  aTags = []
  # 1Ԥ˴ޤޤ뤹٤Ƥλͥ
  aTags.concat(aLine[0].scan(/\[#{sTagRegNcom}\]/))
  aTags.concat(aLine[0].scan(/\[#{sTagRegComA}\]/))

  aTags.each{|sTag|
    if (!hNcomSpecInfo.has_key?(sTag))
      hNcomSpecInfo[sTag] = []
    end
    hNcomSpecInfo[sTag].push("#{aLine[2]}:#{aLine[1]}")
  }
}

# IDǥȤƷ̤
aTagID = hNcomSpecInfo.keys()
aTagID.sort!()
sResult = ""
aTagID.each{|sTag|
  sPlace = ""
  hNcomSpecInfo[sTag].each{|sLine|
    sPlace += "#{sLine}, "
  }
  sPlace.chop!().chop!()

  sResult += "#{sTag} @ #{sPlace}\n"
}

# եؽϤ
File.open("#{TOOL_ROOT}/nces_spec_id.txt", "w") {|io|
  io.puts(sResult)
}

# оݻͤоݻͤνʣå
aNcomSpec = []
aComASpec = []
aTagID.each{|sTag|
  # NCOM
  if (sTag =~ /\[#{sTagRegNcom}\]/)
    aNcomSpec.push(sTag.gsub(/\[(#{sTagRegAll})\]/, "\\1"))
  # COMa
  elsif (sTag =~ /\[#{sTagRegComA}\]/)
    aComASpec.push(sTag.gsub(/\[(#{sTagRegComA})\]/, "\\1"))
  else
    abort("Error!!")
  end
}



#
# ɼ
#
aCodeData = []
aTargetFiles.each{|sFileName|
  sFileData = File.read(sFileName)
  # ԥɤѴ
  if (sFileData.include?("\r\n"))
    sFileData.gsub!("\r\n","\n")
  end
  if (sFileData.include?("\r"))
    sFileData.gsub!("\r","\n")
  end

  aTmpData = sFileData.split("\n")

  # [1ΥɡԿե̾]ΥåȤݻ
  nLine = 1
  aTmpData.each{|sLine|
    aCodeData.push([sLine, nLine, File.basename(sFileName)])
    nLine += 1
  }
}

# 
hSpecInfo = {}

aCodeData.each{|aLine|
  # ͥ¸ߤʤϲ⤷ʤ
  if (aLine[0] !~ /[\[<]#{sTagRegAll}[\]>]/)
    next
  end

  aTags = []
  # 1Ԥ˴ޤޤ뤹٤Ƥλͥ
  aTags.concat(aLine[0].scan(/[\[<]#{sTagRegAll}[\]>]/))

  aTags.each{|sTag|
    if (!hSpecInfo.has_key?(sTag))
      hSpecInfo[sTag] = []
    end
    hSpecInfo[sTag].push("#{aLine[2]}:#{aLine[1]}")
  }
}

# IDǥȤƷ̤
aTagID = hSpecInfo.keys()
aTagID.sort!()
sResult = ""
aTagID.each{|sTag|
  sPlace = ""
  hSpecInfo[sTag].each{|sLine|
    sPlace += "#{sLine}, "
  }
  sPlace.chop!().chop!()

  sResult += "#{sTag} @ #{sPlace}\n"
}

# եؽϤ
File.open("#{TOOL_ROOT}/impl_spec_id.txt", "w") {|io|
  io.puts(sResult)
}

# оݻͤоݻͤνʣå
nAutosarCnt = 0
aTargetSpec = []
aNonTargetSpec = []
aImplComASpec = []
aImplNcomSpec = []
aTagID.each{|sTag|
  # COMa
  if (sTag =~ /\[#{sTagRegComA}\]/)
    aImplComASpec.push(sTag.gsub(/\[(#{sTagRegComA})\]/, "\\1"))
  # NCOM
  elsif (sTag =~ /\[#{sTagRegNcom}\]/)
    aImplNcomSpec.push(sTag.gsub(/\[(#{sTagRegAll})\]/, "\\1"))
  # оݻ
  elsif (sTag =~ /\[#{sTagRegCom}\]/)
    aTargetSpec.push(sTag.gsub(/\[(#{sTagRegCom})\]/, "\\1"))
    nAutosarCnt += 1
  # оݻ
  elsif (sTag =~ /<#{sTagRegCom}>/)
    aNonTargetSpec.push(sTag.gsub(/<(#{sTagRegCom})>/, "\\1"))
    nAutosarCnt += 1
  else
    abort("Error!!")
  end
}

# ݡо/оݤηɽ
puts("=" * 35)
puts("AUTOSAR tags         : #{aTargetSpec.size() + aNonTargetSpec.size()}")
puts("-" * 35)
fRatio = aTargetSpec.size().to_f() / nAutosarCnt * 100
puts("For support tags     : #{aTargetSpec.size()} (#{sprintf('%0.1f', fRatio)}%)")
fRatio = aNonTargetSpec.size().to_f() / nAutosarCnt * 100
puts("For non-support tags : #{aNonTargetSpec.size()} (#{sprintf('%0.1f', fRatio)}%)")
puts("=" * 35)

# ʣɽ
aTargetSpec.each{|sTarget|
  if (aNonTargetSpec.include?(sTarget))
    puts("#{sTarget} is conflicted !!")
    pp hSpecInfo["[#{sTarget}]"]
    pp hSpecInfo["<#{sTarget}>"]
  end
}

# ȼηɽ
puts("=" * 35)
puts("NCOM tags       : #{aNcomSpec.size()}")
puts("Implemented tags: #{aImplNcomSpec.size()}")
fCoverage = aImplNcomSpec.size().to_f() / aNcomSpec.size().to_f() * 100
puts("NCOM Coverage   : #{sprintf('%0.1f', fCoverage)} %")
puts("-" * 35)
puts("COMa tags       : #{aComASpec.size()}")
puts("Implemented tags: #{aImplComASpec.size()}")
fCoverage = aImplComASpec.size().to_f() / aComASpec.size().to_f() * 100
puts("COMa Coverage   : #{sprintf('%0.1f', fCoverage)} %")
puts("=" * 35)

# Ƥʤɽ
aNcomSpec.each{|sTag|
  if (!aImplNcomSpec.include?(sTag))
    puts(sTag)
  end
}
aComASpec.each{|sTag|
  if (!aImplComASpec.include?(sTag))
    puts(sTag)
  end
}

